<template>
    <div :class="$style.chart">
        <div class="text1" :class="$style.title">{{ title }}</div>
        <Line :data="chartData" :options="chartOptionsObj"> </Line>
    </div>
</template>

<script>
import { Chart as ChartJS, CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip } from 'chart.js'
import { Line } from 'vue-chartjs'
import { formatBigNumbers } from '@/utils/utils'
// eslint-disable-next-line
// import * as chartConfig from './chartConfig.js'

ChartJS.register(CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip)
// ChartJS.plugins.register(
//     {
//     afterDatasetsDraw: function (chart) {
//         if (chart.tooltip._active && chart.tooltip._active.length) {
//             var activePoint = chart.tooltip._active[0],
//                 ctx = chart.ctx,
//                 x = activePoint.tooltipPosition().x,
//                 topY = chart.scales['y-axis-0'].top,
//                 bottomY = chart.scales['y-axis-0'].bottom
//             // draw line
//             ctx.save()
//             ctx.beginPath()
//             ctx.moveTo(x, topY)
//             ctx.lineTo(x, bottomY)
//             ctx.lineWidth = 2
//             ctx.strokeStyle = '#07C'
//             ctx.stroke()
//             ctx.restore()
//         }
//     },
// })

export default {
    name: 'ChartComponent',
    components: {
        Line,
    },

    props: {
        title: {
            type: String,
            default: '',
        },
        chartData: {
            type: Object,
            default: () => ({}),
        },
        chartOptions: {
            type: Object,
            default: () => ({}),
        },
        labelOptions: {
            type: Object,
            default: () => ({}),
        },
    },

    data() {
        return {
            defaultChartOptions: {
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
            },
        }
    },

    computed: {
        chartOptionsObj() {
            return {
                ...this.chartOptions,
                // layout: {
                //     autoPadding: false,
                //     padding: 16,
                // },
                layout: {
                    padding: {
                        left: 10,
                        right: 10,
                        top: 10,
                        bottom: 10,
                    },
                },
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                pointHoverBackgroundColor: 'white',
                pointHoverRadius: 5,
                hoverBorderWidth: '3',
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                            maxTicksLimit: 6,
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                            maxTicksLimit: 5,
                            padding: 35,
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
                //-----------------------
                // tooltips: {
                //     xPadding: 20,
                //     yPadding: 20,
                //     boxShadow: '0px 15px 40px 0px rgba(28, 23, 38, 0.15)',
                //     borderColor: 'rgb(255, 0, 0)',
                //     border: '2px solid red',
                // },
                plugins: {
                    tooltip: {
                        mode: 'nearest',
                        bodySpacing: 4,
                        padding: 16,
                        caretPadding: 12,
                        caretSize: 0,

                        xPadding: 20,
                        yPadding: 20,

                        backgroundColor: 'rgb(255, 255, 255)',
                        // borderColor: 'rgba(28, 23, 38, 0.85)',
                        borderColor: 'rgba(28, 23, 38, 0.03)',
                        borderWidth: 5,

                        boxShadow: '0px 15px 40px 0px rgba(28, 23, 38, 0.15)',
                        // bodyShadow: '0px 15px 40px 0px rgba(255, 0, 0, 0.15)',
                        //'16px 16px 0px 0px #f8f7fb',
                        bodyColor: 'rgb(255, 0, 0, 0.15)',
                        titleColor: 'rgb(0, 0, 0)',
                        // usePointStyle: true,
                        displayColors: false,

                        callbacks: {
                            // beforeTitle: function (context) {
                            //     let label = `${formatBigNumbers(context.parsed.y)} Impressions`
                            //     return label
                            // },
                            title: function (context) {
                                console.log('---context')
                                console.log(context)
                                console.log(context[0].chart.ctx.canvas)
                                let ctx = context[0].chart.ctx,
                                    // x = activePoint.tooltipPosition().x,
                                    x = context[0].parsed.x,
                                    topY = context[0].chart.scales.y.top,
                                    bottomY = context[0].chart.scales.y.bottom
                                // topY = chart.scales['y-axis-0'].top,
                                // bottomY = chart.scales['y-axis-0'].bottom
                                // draw line
                                // ctx.save()
                                ctx.beginPath()
                                ctx.moveTo(x, topY)
                                ctx.lineTo(x, bottomY)
                                ctx.lineWidth = 2
                                ctx.strokeStyle = '#07C'
                                ctx.stroke()
                                ctx.restore()

                                let label = context[0].element.label
                                return label
                            },
                            label: function (context) {
                                let label = `${formatBigNumbers(context.parsed.y)} Impressions`
                                return label
                            },
                            labelColor: function () {
                                return {
                                    // border: 'none',
                                    // // backgroundColor: 'rgb(255, 255, 255)',
                                    backgroundColor: 'rgb(0, 0, 0)',
                                    // boxShadow: '0px 32px 0px 0px #f8f7fb',
                                    // borderRadius: 12,
                                    // color: '#1c1726',
                                    // display: 'none !important',
                                    // width: '0px',
                                }
                            },
                            // beforeLabel: () => null,
                            // beforeTitle: () => ' ',
                            // usePointStyle: true,
                            labelTextColor: function () {
                                return 'rgb(0, 0, 0)' //'#1c1726'
                            },
                            // usePointStyle: true,
                            // labelPointStyle: function () {
                            //     return {
                            //         pointStyle: 'triangle',
                            //         width: '0px',
                            //         rotation: 0,
                            //     }
                            // },
                            ...this.labelOptions,
                        },
                    },
                    afterDatasetsDraw: function (chart) {
                        console.log('---chart')
                        console.log(chart)
                        if (chart.tooltip._active && chart.tooltip._active.length) {
                            var activePoint = chart.tooltip._active[0],
                                ctx = chart.ctx,
                                x = activePoint.tooltipPosition().x,
                                topY = chart.scales['y-axis-0'].top,
                                bottomY = chart.scales['y-axis-0'].bottom
                            // draw line
                            ctx.save()
                            ctx.beginPath()
                            ctx.moveTo(x, topY)
                            ctx.lineTo(x, bottomY)
                            ctx.lineWidth = 2
                            ctx.strokeStyle = '#07C'
                            ctx.stroke()
                            ctx.restore()
                        }
                    },
                },
            }
        },
    },
}
</script>

<style module>
.chart {
    height: 250px;
}
.title {
    margin-bottom: 16px;
    font-size: 16px;
    font-weight: 700;
    line-height: 20px;
}
</style>
